<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_ProductSupplier StructType
 * @subpackage Structs
 */
class JP_ProductSupplier extends AbstractStructBase
{
    /**
     * The External
     * Meta information extracted from the WSDL
     * - use: required
     * @var bool
     */
    public $External;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * Constructor method for JP_ProductSupplier
     * @uses JP_ProductSupplier::setExternal()
     * @uses JP_ProductSupplier::setName()
     * @uses JP_ProductSupplier::setCode()
     * @param bool $external
     * @param string $name
     * @param string $code
     */
    public function __construct($external = null, $name = null, $code = null)
    {
        $this
            ->setExternal($external)
            ->setName($name)
            ->setCode($code);
    }
    /**
     * Get External value
     * @return bool
     */
    public function getExternal()
    {
        return $this->External;
    }
    /**
     * Set External value
     * @param bool $external
     * @return \StructType\JP_ProductSupplier
     */
    public function setExternal($external = null)
    {
        // validation for constraint: boolean
        if (!is_null($external) && !is_bool($external)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($external, true), gettype($external)), __LINE__);
        }
        $this->External = $external;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_ProductSupplier
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\JP_ProductSupplier
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
}
